package trismegistoplanilla.mysqldao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import trismegistoplanilla.dao.AreaCargoDAO;
import trismegistoplanilla.dao.AreaCargoTipoPagoDAO;
import trismegistoplanilla.dao.AreaDAO;
import trismegistoplanilla.dao.CargaFamiliarDAO;
import trismegistoplanilla.dao.CargoDAO;
import trismegistoplanilla.dao.CarreraProfesionalDAO;
import trismegistoplanilla.dao.ConfiguracionFichaDAO;
import trismegistoplanilla.dao.DAOFactory;
import trismegistoplanilla.dao.DetalleLoteFichaDocenteDAO;
import trismegistoplanilla.dao.EscalafonDAO;
import trismegistoplanilla.dao.EstadoCivilDAO;
import trismegistoplanilla.dao.EstadoEstudioDAO;
import trismegistoplanilla.dao.EstadoFichaDAO;
import trismegistoplanilla.dao.ExpedienteDAO;
import trismegistoplanilla.dao.ExperienciaLaboralDAO;
import trismegistoplanilla.dao.FichaDAO;
import trismegistoplanilla.dao.FichaLaboralDAO;
import trismegistoplanilla.dao.FondoPensionDAO;
import trismegistoplanilla.dao.FormacionAcademicaDAO;
import trismegistoplanilla.dao.LoteFichaDAO;
import trismegistoplanilla.dao.NacionalidadDAO;
import trismegistoplanilla.dao.NivelEstadoDAO;
import trismegistoplanilla.dao.NivelEstudioDAO;
import trismegistoplanilla.dao.ParentescoDAO;
import trismegistoplanilla.dao.PersonaDAO;
import trismegistoplanilla.dao.ReportePersonalDAO;
import trismegistoplanilla.dao.SedeAreaDAO;
import trismegistoplanilla.dao.SedeDAO;
import trismegistoplanilla.dao.TipoDocumentoDAO;
import trismegistoplanilla.dao.TipoEstadoFichaDAO;
import trismegistoplanilla.dao.TipoExpedienteDAO;
import trismegistoplanilla.dao.TipoPagoDAO;
import trismegistoplanilla.dao.TokenFichaDAO;
import trismegistoplanilla.dao.TrabajadorResponsableDAO;
import trismegistoplanilla.dao.UbigeoDAO;
import trismegistoplanilla.dao.VacanteDAO;

public class MysqlDAOFactory extends DAOFactory {

	static {
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (ClassNotFoundException ex) {
			ex.printStackTrace();
		}
	}

	public static Connection obtenerConexion(String base) {
		Connection conexion = null;
		String user;
		String pwd;
		String url;

		if (base.equalsIgnoreCase("nuevo")) {
			user = "juanjose";
			pwd = "juanjose";
			url = "jdbc:mysql://172.16.2.37:3306/nuevo";
			try {
				conexion = DriverManager.getConnection(url, user, pwd);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

		return conexion;
	}

	@Override
	public TipoDocumentoDAO getTipoDocumentoDAO() {
		return new TipoDocumentoMysqlDAO();
	}

	@Override
	public PersonaDAO getPersonaDAO() {
		return new PersonaMysqlDAO();
	}

	@Override
	public FichaDAO getFichaDAO() {
		return new FichaMysqlDAO();
	}

	@Override
	public TokenFichaDAO getTokenFichaDAO() {
		return new TokenFichaMysqlDAO();
	}

	@Override
	public EstadoCivilDAO getEstadoCivilDAO() {
		return new EstadoCivilMysqlDAO();
	}

	@Override
	public NacionalidadDAO getNacionalidadDAO() {
		return new NacionalidadMysqlDAO();
	}

	@Override
	public UbigeoDAO getUbigeoDAO() {
		return new UbigeoMysqlDAO();
	}

	@Override
	public ParentescoDAO getParentescoDAO() {
		return new ParentescoMysqlDAO();
	}

	@Override
	public CargaFamiliarDAO getCargaFamiliarDAO() {
		return new CargaFamiliarMysqlDAO();
	}

	@Override
	public CarreraProfesionalDAO getCarreraProfesionalDAO() {
		return new CarreraProfesionalMysqlDAO();
	}

	@Override
	public NivelEstudioDAO getNivelEstudioDAO() {
		return new NivelEstudioMysqlDAO();
	}

	@Override
	public EstadoEstudioDAO getEstadoEstudioDAO() {
		return new EstadoEstudioMysqlDAO();
	}

	@Override
	public NivelEstadoDAO getNivelEstadoDAO() {
		return new NivelEstadoMysqlDAO();
	}

	@Override
	public FondoPensionDAO getFondoPensionDAO() {
		return new FondoPensionMysqlDAO();
	}

	@Override
	public ExperienciaLaboralDAO getExperienciaLaboralDAO() {
		return new ExperienciaLaboralMysqlDAO();
	}

	@Override
	public FormacionAcademicaDAO getFormacionAcademicaDAO() {
		return new FormacionAcademicaMysqlDAO();
	}

	@Override
	public SedeDAO getSedeDAO() {
		return new SedeMysqlDAO();
	}

	@Override
	public AreaDAO getAreaDAO() {
		return new AreaMysqlDAO();
	}

	@Override
	public SedeAreaDAO getSedeAreaDAO() {
		return new SedeAreaMysqlDAO();
	}

	@Override
	public TrabajadorResponsableDAO getTrabajadorResponsableDAO() {
		return new TrabajadorResponsableMysqlDAO();
	}

	@Override
	public CargoDAO getCargoDAO() {
		return new CargoMysqlDAO();
	}

	@Override
	public EscalafonDAO getEscalafonDAO() {
		return new EscalafonMysqlDAO();
	}

	@Override
	public EstadoFichaDAO getEstadoFichaDAO() {
		return new EstadoFichaMysqlDAO();
	}

	@Override
	public FichaLaboralDAO getFichaLaboralDAO() {
		return new FichaLaboralMysqlDAO();
	}

	@Override
	public AreaCargoDAO getAreaCargoDAO() {
		return new AreaCargoMysqlDAO();
	}

	@Override
	public TipoPagoDAO getTipoPagoDAO() {
		return new TipoPagoMysqlDAO();
	}

	@Override
	public AreaCargoTipoPagoDAO getAreaCargoTipoPagoDAO() {
		return new AreaCargoTipoPagoMysqlDAO();
	}

	@Override
	public LoteFichaDAO getLoteFichaDAO() {
		return new LoteFichaMysqlDAO();
	}

	@Override
	public TipoEstadoFichaDAO getTipoEstadoFichaDAO() {
		return new TipoEstadoFichaMysqlDAO();
	}

	@Override
	public DetalleLoteFichaDocenteDAO getDetalleLoteFichaDocenteDAO() {
		return new DetalleLoteFichaDocenteMysqlDAO();
	}

	@Override
	public ExpedienteDAO getExpedienteDAO() {
		return new ExpedienteMysqlDAO();
	}

	@Override
	public TipoExpedienteDAO getTipoExpedienteDAO() {
		return new TipoExpedienteMysqlDAO();
	}

	@Override
	public ConfiguracionFichaDAO getConfiguracionFichaDAO() {
		return new ConfiguracionFichaMysqlDAO();
	}

	@Override
	public ReportePersonalDAO getReportePersonalDAO() {
		return new ReportePersonalMysqlDAO();
	}

	@Override
	public VacanteDAO getVacanteDAO() {
		return new VacanteMysqlDAO();
	}

}
