package trismegistoplanilla.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.json.JSONObject;
import trismegistoplanilla.beans.AreaBean;
import trismegistoplanilla.beans.SedeBean;
import trismegistoplanilla.dao.SedeAreaDAO;
import trismegistoplanilla.utilities.ResponseHelper;
import trismegistoplanilla.utilities.Variables;

public class SedeAreaMysqlDAO implements SedeAreaDAO {

	@Override
	public JSONObject obtenerSedeArea(SedeBean s, AreaBean a) {
		System.out.println("SedeAreaMysqlDAO: obtenerSedeArea");
		JSONObject JOObtenerSedeArea = null;
		ResponseHelper response = new ResponseHelper();

		String sql = "SELECT "
			+ "	sede_area.codigo_sede_area codigoSedeArea "
			+ "FROM "
			+ "	sede_area "
			+ "WHERE "
			+ "	sede_area.codigo_sede = ? "
			+ "AND sede_area.codigo_area = ? "
			+ "AND sede_area.estado_registro = 1";

		Connection conexion = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		try {
			conexion = MysqlDAOFactory.obtenerConexion(Variables.MYSQL_NUEVO_BD_NAME);
			ps = conexion.prepareStatement(sql);
			ps.setInt(1, s.getCodigoSede());
			ps.setInt(2, a.getCodigoArea());
			rs = ps.executeQuery();
			rs.next();
			int codigoSedeArea = rs.getInt("codigoSedeArea");
			if (codigoSedeArea > 0) {
				JSONObject objSedeArea = new JSONObject();
				objSedeArea.put("getResultedKey", codigoSedeArea);
				response.setStatus(true);
				response.setMessage("Se encontró el código");
				response.setData(objSedeArea);
			} else {
				response.setStatus(false);
				response.setMessage("Error! no se ha podido encontrar el código sede area");
			}
		} catch (SQLException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error: " + e.getMessage() + "   Error Code: [" + e.getErrorCode() + "]");
		} finally {
			try {
				if (rs != null) {
					rs.close();
				}
				if (ps != null) {
					ps.close();
				}
				if (conexion != null) {
					conexion.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		JOObtenerSedeArea = new JSONObject(response);
		return JOObtenerSedeArea;
	}

}
