package trismegistoplanilla.servicesMysql;

import org.json.JSONObject;
import trismegistoplanilla.beans.TipoDocumentoBean;
import trismegistoplanilla.beans.TokenFichaBean;
import trismegistoplanilla.dao.DAOFactory;
import trismegistoplanilla.dao.TipoDocumentoDAO;

public class TipoDocumentoService {

	DAOFactory factory = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
	TipoDocumentoDAO objTipoDocumentoDAO = factory.getTipoDocumentoDAO();

	public JSONObject listarTipoDocumento() {
		JSONObject jsonObjListarTipoDocumento = null;
		try {
			jsonObjListarTipoDocumento = objTipoDocumentoDAO.listarTipoDocumento();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObjListarTipoDocumento;
	}

	public JSONObject validarExistenciaTipoDocumento(TipoDocumentoBean tipoDocumento) {
		JSONObject jsonObjValidarExistenciaTipoDocumento = null;
		try {
			jsonObjValidarExistenciaTipoDocumento = objTipoDocumentoDAO.validarExistenciaTipoDocumento(tipoDocumento);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObjValidarExistenciaTipoDocumento;
	}

	public JSONObject obtenerLongitudTipoEntrdadaTipoDocumento(TipoDocumentoBean tipoDocumento) {
		JSONObject jsonObjObtenerLongitudTipoEntrdadaTipoDocumento = null;
		try {
			jsonObjObtenerLongitudTipoEntrdadaTipoDocumento = objTipoDocumentoDAO.obtenerLongitudTipoEntrdadaTipoDocumento(tipoDocumento);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObjObtenerLongitudTipoEntrdadaTipoDocumento;
	}

	public JSONObject obtenerCodigoTipoDocumento(TokenFichaBean tf) {
		JSONObject jsonObjObtenerCodigoTipoDocumento = null;
		try {
			jsonObjObtenerCodigoTipoDocumento = objTipoDocumentoDAO.obtenerCodigoTipoDocumento(tf);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObjObtenerCodigoTipoDocumento;
	}

}
