package trismegistoplanilla.servicesMysql;

import org.json.JSONObject;
import trismegistoplanilla.beans.TokenFichaBean;
import trismegistoplanilla.dao.DAOFactory;
import trismegistoplanilla.dao.TokenFichaDAO;

public class TokenFichaService {

	DAOFactory factory = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
	TokenFichaDAO objTokenFichaDAO = factory.getTokenFichaDAO();

	public JSONObject validarTokenURL(TokenFichaBean tf) {
		JSONObject jsonObjValidarTokenURL = null;
		try {
			jsonObjValidarTokenURL = objTokenFichaDAO.validarTokenURL(tf);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObjValidarTokenURL;
	}

	public JSONObject validarToken(TokenFichaBean tf) {
		JSONObject jsonObjValidarExistenciaToken = null;
		try {
			jsonObjValidarExistenciaToken = objTokenFichaDAO.validarToken(tf);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObjValidarExistenciaToken;
	}

	public JSONObject desactivarToken(TokenFichaBean tf) {
		JSONObject jsonObjDesactivarToken = null;
		try {
			jsonObjDesactivarToken = objTokenFichaDAO.desactivarToken(tf);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObjDesactivarToken;
	}

	public JSONObject obtenerSedeAreaCargo(JSONObject datos) {
		JSONObject jsonReturn = null;
		try {
			jsonReturn = objTokenFichaDAO.obtenerSedeAreaCargo(datos);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonReturn;
	}
}
